package testme.myapp.com.ntrp.fragments;

import android.app.Dialog;
import android.app.ProgressDialog;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.fragment.app.Fragment;
import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.android.volley.AuthFailureError;
import com.android.volley.DefaultRetryPolicy;
import com.android.volley.Request;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.VolleyLog;
import com.android.volley.toolbox.StringRequest;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

import java.util.HashMap;
import java.util.Map;

import butterknife.BindView;
import testme.myapp.com.ntrp.R;


import butterknife.ButterKnife;
import testme.myapp.com.ntrp.adapters.FAQAdaptor;
import testme.myapp.com.ntrp.adapters.HomeAdaptor;
import testme.myapp.com.ntrp.extra.MyToken;
import testme.myapp.com.ntrp.model.FAQModel;
import testme.myapp.com.ntrp.module_donatetoswachhbharatkosh.adaptors.ChannelListAdaptor;
import testme.myapp.com.ntrp.module_donatetoswachhbharatkosh.fragments.PaymentFragment;
import testme.myapp.com.ntrp.module_donatetoswachhbharatkosh.models.ChannelListModel;
import testme.myapp.com.ntrp.networking.AppController;
import testme.myapp.com.ntrp.networking.HandleHttpsRequest;
import testme.myapp.com.ntrp.utils.AllUrls;

public class FAQFragment extends Fragment {

    /*@BindView(R.id.recycler_view)
    RecyclerView recyclerView;*/

    private String html_content=" <!DOCTYPE html> <html lang=\"en\"> <body> <div class=\"container container-l\"> <h2>FAQs</h2> <hr> <div class=\"footer-page-heading\"> <div class=\"tab-content faq_tab_content\"> <div id=\"CommonFAQs\" class=\"tab-pane fade in active\"> <div class=\"panel-group faq_panel_group\" id=\"accordion\"> <b>Question 1. What are the channels available to depositors?</b><br> <b>Answer: -</b>The Internet Banking (Individual Corporate), Debit and Credit Cards based on integration available from the respective the resource.<br> <b>Question 2. Can depositor use NEFT/RTGS if he/she does not have access to these channels?</b><br> <b>Answer: -</b>The depositor can use NEFT/RTGS mode for depositing the Challan. The Challan (GAR-7)/ Deposit slip can be generated and the amount can be remitted to the designated bank by intra-bank transfer or using NEFT/RTGS using the format generated by the Bharatkosh system. After successful payment user has to enter UTR no. against the said transaction on Bharatkosh under the Track Your Payment<br> <b>Question 3.The user while making the payment through NEFT/RTGS has filled all the details i.e. Bank Account number, IFSC code etc., and has also generated the mandate form and made the payment through the bank, but still copy of Challan is not generated?</b><br> <b>Answer: -</b> It should be ensured that while filling up the mandate form and providing details viz. account number, IFSC code, the same account number should be debited while making payment. There are instances where the user provides different account information on the mandate form and make the payment through another account.<br> <b>Question 4. User has made the payment of service through NEFT/RTGS and is not able to print a copy ofChallan (GAR7)?</b><br> <b>Answer: -</b> The user should be apprised to enter the correct UTR Number against the payment made by clicking on Track Your Payment/Payment History at Bharatkosh.<br> <b>Question 5. Procedure for Generation of Challan (GAR-7) for NEFT/RTGS transaction.</b><br> <b>Answer: -</b> Please follow the link given below. https://bharatkosh.gov.in/TrackTransaction/VerifyUser Fill in your details and enter OTP received on your email/Mobile and click verify. On the very right side you will see a column named \"Enter UTR NO.\" Click on the hyperlink and enter UTR No. provided by the Bank and wait until it gets verified. You may also follow the guidelines regarding the NEFT user guide, which is available on Bharatkosh website.<br> <b>Question 6. The user has entered the UTR Number at Bharatkosh against the payment made through NEFT/RTGS but still, he is not able to print GAR7?</b><br> <b>Answer: -</b> The user should check first that the UTR number entered is correct or not. After checking its accuracy the user should approach Bharatkosh team.<br> <b>Question 7 Transaction is not appearing for updating UTR No. on Bharatkosh?</b><br> <b>Answer</b> Transaction may be archived or wiped out from the system due to non updating UTRN Number within 15 days.<br> <b>Question 8. Incomplete Payment through NEFT via Bharatkosh i.e. Mandate form not generated through Bharatkosh and payment made directly to PAO RBI Account / UTR No. not entered against the transaction</b><br> <b>Answer: -</b> User has to generate a mandate form for the transaction with details for which payment was made and update the UTR number given by the bank against the transaction.<br> <b>Question 9. What is the role of an aggregator?</b><br> <b>Answer: -</b> FAQs Aggregator is the Payment Aggregator service that provides multiple payment options on a single payment page for the convenience of depositors of Bharatkosh.<br> <b>Question 10.What are all the payment modes available on the aggregator page?</b><br> <b>Answer: -</b> Aggregator facilitates online payments through all Credit and Debit Cards issued by MasterCard, Maestro, VISA, RuPay based on their arrangements and thus they can add and drop such arrangements over a period of time it also facilitated transactions through Internet Banking and payment service of empanelled Banks.<br> <b>Question 11. Is it possible to pay directly using an Internet Banking account from my bank?</b><br> <b>Answer: -</b> This is possible for you by two ways: <br> (i) Non-Tax Receipt Portal has arrangement with your banker <br> (ii) You can remit amount using reference Challan no. through NEFT/RTGS of your bank.<br> <b>Question 12. Are transactions on Aggregator service secure?</b><br> <b>Answer: -</b> Aggregators are certified with Payment Card Industry Data Security Standard (PCI DSS) ver. 2.0 certified, which reinforces our promise of security. It has also obtained the PADSS Certification. The payment system follows secured processes and also supports 3DSecure - Verified by Visa and MasterCard Secure Code, and second-factor authorization as facilitated by respective Banks for Internet Banking Service, wherever applicable. Further, aggregators use Secure Sockets Layer (SSL) encryption which ensures that payment information is never sent over the Internet unencrypted and cannot be viewed by unauthorized intruders in the network.<br> <b>Question 13. How a customer/depositor can understand that payment has been made successfully?</b><br> <b>Answer: -</b> The depositor after filling in details on Bharatkosh website and clicking \"Pay\", the depositor is redirected to the selected aggregators payment page and is presented with payment options like Debit Card,<br> Credit Card, and Internet Banking. Depositor enters his details and clicks \"Proceed\". Then the depositor may see one of the two options:<br> (i)For internet banking: User ID password page of Banks FAQs<br> (ii)For cards: Fields to Enter Card details and 3D Secure page.<br> After successful completion of the transaction, the depositor is redirected to the website with a successful receipt of payment. <br> <b>Question 14. How do I know that my Bank participates in 3D Secure transactions?</b><br> <b>Answer: -</b> If a depositor is presented with a 3D Secure page prompting to enter a password/OTP on the aggregator page, this means the Card issuing Bank participates in 3D Secure transaction. This is mandatory in India for Card transactions.<br> <b>Question 15. Subscription/payment made for the Yojana/Kurukshetra books/magazines but didn't receive a copy of the same. </b> <br> <b>Answer: -</b> Please contact the concerned Department for providing the service.<br> <b>Question 16. Request for Change of Address for the supply of books/magazines.</b><br> <b>Answer: -</b> Please contact the concerned Department for providing the service.<br> <b>Question 17. The user wanted to know by when he will receive his order since he couldn't figure out theorder number and has attached the screenshot of the transaction. </b> <br> <b>Answer: - </b>For obtaining the service/order please contact the concerned Department. Bharatkosh is just a payment gateway for receiving online payment on behalf of various Ministries.<br> <b>Question 18. The user wants to make the payment through Corporate Net Banking but is not able to do so.</b><br> <b>Answer: -</b> Currently PGAs do not permit Corporate Net Banking for all banks. User may change Payment Gateway to see which PGA support Corporate Net Banking for his/her bank.<br> <b>Question 19. Unable to make payment on Bharatkosh</b><br> <b>Answer: -</b> You may change the browser and delete the cookies to overcome this issue. And also please follow the user guide, which is available on Bharatkosh website.<br> <b>Question 20. On Bharatkosh Website payment to DoT option is not appearing.</b><br> <b>Answer: -</b> User has to create a login ID specifically for DoT, then only the receipt purpose will be visible for making payment.<br> <b>Question 21. The user by mistake made a payment for an FRTO license renewal but this license is actually stillvalid. The amount paid was INR 2500.This was an error on user's part. The user requested to kindly reverse the transaction as this process needs to be done much later and also demanded a refund of the said amount. </b> <br> <b>Answer: -</b> For any refund, user is requested to contact the concerned department along with receipt/Challan.<br> <b>Question 22. A user made a payment of Rs. 5000/- towards Pilot licensing (Mumbai) and receipt of transaction Id is also attached. The user has requested to cancel this transaction as he was supposed to make two different transactions which he did later of 2500/- each.</b> <br> <b>Answer: -</b> For any refund, the user is requested to contact the concerned department along with receipt/Challan.<br> <b>Question 23. User account is debited but the transaction is shown failed</b><br> <b>Answer: -</b> In case the amount has been debited from your bank account/ credit card/ debit card, please do not make another payment and keep checking the status of your payment at the following URL: https://bharatkosh.gov.in/TrackTransaction/VerifyUser. Against the transaction ref. no. click on the hyperlink Know your current status If the transaction status is \"FAIL OR REFUND IF SETTLED\" then the amount will be credited back in the user's bank account within 7-10 working days. In every other status appearing on Bharatkosh, please Contact Bharatkosh Helpdesk.<br> <b>Question 24. User account has been debited but the transaction status is not successful.</b><br> <b>Answer: -</b> If the transaction status is \"FAIL OR REFUND IF SETTLED\" then the amount will be credited back in the user's bank account within 7-10 working days. In every other status appearing on Bharatkosh, please Contact Bharatkosh Helpdesk.<br> <b>Question 25. Online Payment NOT WORKING</b><br> <b>Answer: -</b> Try again after clicking a different Payment gateway<br> <b>Question 26. The user requires the services at Bangalore but inadvertently has selected the PAO and DDO of Delhi while making payment?</b><br> <b>Answer:-</b> Providing of service stands at the sole discretion of DDOs/PAOs, hence the DDO/PAO can either internally adjust the service fee between their DDOs or they can refund the fee amount to the user where it has been wrongly paid with the instructions to pay it again to the DDO/PAO from where the services are required.<br> <b>Question 27. The user has selected the wrong purpose while making payment at Bharatkosh</b><br> <b>Answer: -</b> The user has to apply for a refund with the respective DDO along with receipt/Challan and PAO will refund the amount to the user. User will write to the Concerned DDO in Ministry (e-Mail address will be available on Bharatkosh) within 15 days of the transaction. DDO in return will acknowledge the receipt of such request through mail to user and Bharatkosh. DDO shall carry out the due diligence for necessary evidence/proof from the user regarding the fraudulent use of the card and will check the merit of the claim and a decision on refund claim will be taken. It shall be the discretion and decision of the DDO to involve any other authority on law and order in this regard. If Refund claim is accepted by the concerned DDO in the service department (Ministry), a refund as per Government Financial Rules (GFR), through the generation of financial sanction will be initiated. Concerned DDO will generate a sanction and the respective PAO will make the payment to the user on sanction. The refund would be the sole discretion of the respective service department (DDO in Ministry) and Bharatkosh shall not be held responsible for any refund claims. The user has to again make the payment on Bharatkosh by selecting the correct purpose.<br> <b>Question 28.The user has selected the wrong PAO/DDO while making payment at Bharatkosh</b><br> <b>Answer: -</b> It is at the sole discretion of the concerned PAO to either adjust the amount within its PAOs or refund the amount to the user. The refund process will be the same as mentioned above.<br> <b>Question 29. User has registered himself/herself in Bharatkosh. However, at the time of making payment, purposes of Department of Telecom not listed even under ministry list TELECOMMUNICATION not available.</b><br> <b>Answer: -</b> For making a payment for purposes of the Department of Telecom, users must have to select Controller name - Telecommunication\" during registration in Bharatkosh.<br> <b>Question 30. At the Make your payment page, some purposes of DoT such as Basic Services, CMRTS, UASL,USALS-DT and Unified license for Access Services are not available.</b><br> <b>Answer: -</b> For these purposes, user has to validate. For validation click on \"My Account\" \"Validation for DoT\".<br> <b>Question 31. User has registered himself/herself in Bharatkosh as user category PSU/Individual for DoT. Somepurposes are not visible on Bharatkosh -Make Your Payment page.</b><br> <b>Answer: -</b> User is requested to contact concerned department/PAO. Maybe these purposes are mapped only for the User category- Corporate. Users can request to update those purposes for PSU also.<br> <b>Question 32. In Bharatkosh Track Your Payment page user is not able to see transactions details for which deposit slip was created in the previous F.Y.</b><br> <b>Answer: -</b> Now, at Track Your Payment page of Bharatkosh, information of transactions is automatically shown for the current financial year. If depositor needs to see the transactions made during the previous financial year they have to select F/Y accordingly.<br> <b>Question 33. Details of the transactions not available in Track Your Payment initiated by a person other than the registered user.</b><br> <b>Answer: -</b> In Track Your Payment page transactions are filtered by the system by default as per the mobile no and email id updated by the registered user. When another person initiated a transaction by updating his mobile no and email id then the transaction is not visible at track your payment page by default. Hence, users can find out this transaction by clicking on the clear filter. Or the transaction might have been archived.<br> <b>Question 34. Depositor pays an amount extra than supposed payment, the process for a refund</b><br> <b>Answer: -</b> The refunds for Bharatkosh payment are totally the prerogative of the concerned DDO / Department who owns the non-tax collected, upon receipt of the request for a refund the concerned PD/Dept. would take a decision based on merits of the individual case and in case they approve refund the due process for payment out of Consolidated Fund of India vide a sanction, a bill, pre-check process, and e-payment into beneficiary's bank account follows.<br> <b>Question 35. A wrong entry in the depositor details page is made by a depositor, what is the process to rectify that?</b><br> <b>Answer: -</b> In the case of a registered Bharatkosh user, the depositorscanhimself/herself log in and change the details for all subsequent payments. For a non-registered user or a retrospective change, the depositor needs to contact the Bharatkosh helpdesk (via phone /e-mail) to make the changes.<br> <b>Question 36. How to generate receipt on Bharatkosh.</b><br> <b>Answer: -</b> Please follow the link given below. https://bharatkosh.gov.in/TrackTransaction/VerifyUser. Fill in your details and enter OTP received on your email/Mobile and click verify. Now you can see your all transactions made up to date. For transaction receipt, click on the blue color hyperlink (transaction ref. no.) to get transaction receipt and Challan.<br> <b>Question 37. User has made the payment on Bharatkosh and the payment was successful but the user did not get any Transaction Ref. number. </b> <br> <b>Answer: -</b> Please follow the link given below. https://bharatkosh.gov.in/TrackTransaction/VerifyUser. Fill in your details and enter OTP received on your email/Mobile and click verify. Now you can see your all transactions made up to date. For transaction receipt, click on the blue color hyperlink (transaction ref. no.) to get the transaction receipt and Challan.<br> <b>Question 38.The user while making an Online payment (Credit Card/Debit Card/Net banking) has inadvertently made the payment more than once due to lag of system/network issues and now the user wants a refund for the same?</b><br> <b>Answer: -</b> As per the Terms and Conditions and Charge-back and Refund Policy at Bharatkosh the user should first contact the respective DDO from where he/she was to require the services and provide the details of double/more than one payment transaction who will in-turn, after confirmation from Bharatkosh for the same, can process the refund at their end for the transactions for which the services have not been rendered.<br> <b>Question 39. Can International payments be processed?</b><br> <b>Answer: -</b> This service will be launched soon.<br> <b>Question 40. What is the support available for the depositors?</b><br> <b>Answer: -</b> Bharatkosh is supported by technical support for all deposit-related transactions. Email us at ntrp-helpdesk[at]gov[dot]in for any queries, transaction details, or any other issues.<br> </div> </div> <div id=\"PublicationFAQs\" class=\"tab-pane fade\"> <b>1. From which date/issue my subscription will start? </b><br/> Your subscription will starts from next available issue after processing of your payment. The schedule dispatch dates of journals (published and circulated from Delhi) are as under:<br /> <br /> <table > <tr> <td >Ajkal Urdu </td> <td>15th & 16th of previous month</td> </tr> <tr> <td >Bal Bharti</td> <td>18th & 19th of previous month</td> </tr> <tr> <td > Ajkal Hindi </td> <td>21st & 22nd of previous month</td> </tr> <tr> <td >Yojana English</td> <td>25th & 26th of previous month</td> </tr> <tr> <td >Yojana Hindi </td> <td> 29th & 30th of previous month </td> </tr> <tr> <td >Kurukshetra English</td> <td>2nd & 3rd of same month </td> </tr> <tr> <td >Kurukshetra Hindi</td> <td>5th & 6th of same month</td> </tr> <tr> <td >Yojana (Oriya/Punjabi/Urdu) </td> <td>has no specific date of dispatch.</td> </tr> </table> <br/> <p> <strong>Q.2 To whom I will contact in case of any query/complaint? </strong> </p> <p> In case of any query/complaint please contact Officer-in-Charge of Journals Unit, Publications Division, Room No. 48-53, Soochana Bhawan, CGO Complex, Lodi Road, New Delhi 110 003. Email: pdjucir[at]gmail[dot]com or 011-24367453 available in all working days (Monday to Friday) during office hours (9.30 am to 6.00pm).</p> <p> <strong> Q.3 What is mode of dispatch of Journals? </strong> </p> <p> All the journals are send to subscribers through ordinary post. It is pertinent to mention here that Department of Posts does not provide any tracking number or proof of delivery for the same.</p> <p> <strong>Q.4 Is there any provision of refund/adjustment of subscription fee in case of non-receipt of journals?</strong> </p> <p> No, there is no such provision. </p> <p> <strong>Q.5 Can I change my address during subscription period? </strong> </p> <p> Yes, you can change your address any time by informing us your old as well as new address and request for change the same in writing. </p> </div> <div class=\"clearfix\"></div> </body> </html>";


    @BindView(R.id.faq_web_view)
    public WebView faq_web_view;
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {

        View view = inflater.inflate(R.layout.fandq_fragment, container, false);
        ButterKnife.bind(this, view);
        getActivity().setTitle(this.getActivity().getResources().getString(R.string.menu_faq));


       /* recyclerView.setHasFixedSize(true);

        GridLayoutManager mLayoutManager = new GridLayoutManager(this.getContext(), 1);
        mLayoutManager.setOrientation(RecyclerView.VERTICAL);

        recyclerView.setLayoutManager(mLayoutManager);


        Hit_FAQ_API();*/


        faq_web_view.setWebViewClient(new WebViewClient());
        WebSettings set = faq_web_view.getSettings();
        set.setJavaScriptEnabled(true);
        set.setBuiltInZoomControls(true);
        faq_web_view.loadData(html_content, "text/html", "UTF-8");

        return view;
    }

    /*public void Hit_FAQ_API() {

        HandleHttpsRequest.setSSL();


        System.out.println("Hit_FAQ_API..............");
        String tag_json_obj = "json_obj_req";
        String url = AllUrls.getFAQURL;
        final ProgressDialog pDialog = new ProgressDialog(this.getActivity(),R.style.MyTheme);
        pDialog.setMessage("Loading...");
        pDialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
        pDialog.setCancelable(false);
        pDialog.show();


        StringRequest strReq = new StringRequest(Request.Method.POST,
                url, new Response.Listener<String>() {

            @Override
            public void onResponse(String response) {

                int maxLogSize = 1000;
                for (int i = 0; i <= response.length() / maxLogSize; i++) {
                    int start = i * maxLogSize;
                    int end = (i + 1) * maxLogSize;
                    end = end > response.length() ? response.length() : end;
                    Log.v("abc.....", response.substring(start, end));
                }



                pDialog.hide();
                pDialog.dismiss();
                Gson gson = new GsonBuilder().setLenient().create();

                FAQModel channelListModel=gson.fromJson(response,FAQModel.class);



                if (channelListModel.getObjfaq().size()!=0)
                {



                    FAQAdaptor adaptor = new FAQAdaptor(channelListModel.getObjfaq());
                    recyclerView.setAdapter(adaptor);
                    adaptor.notifyDataSetChanged();


                }
                else {
                    showDialog_ServerError("Some Error occured !");

                }



            }

        }, new Response.ErrorListener() {

            @Override
            public void onErrorResponse(VolleyError error) {
                VolleyLog.d("goterror= ", "Error: " + error.getMessage());
                System.out.println("Got error= "+error.getMessage());
                pDialog.hide();
                pDialog.dismiss();
                showDialog_ServerError("Server Error, Please Try again later");
            }
        })
        {
            @Override
            protected Map<String, String> getParams() {
                Map<String, String> params = new HashMap<String, String>();


                return params;
            }

            @Override
            public Map<String, String> getHeaders() throws AuthFailureError {
                Map<String, String> headers = new HashMap<>();
                // headers.put("Content-Type", "application/x-www-form-urlencoded");
                headers.put("Authorization", "Bearer "+ MyToken.getAuthorization());
                return headers;
            }

        };




        strReq.setRetryPolicy(new DefaultRetryPolicy(DefaultRetryPolicy.DEFAULT_TIMEOUT_MS, DefaultRetryPolicy.DEFAULT_MAX_RETRIES, DefaultRetryPolicy.DEFAULT_BACKOFF_MULT));
        AppController.getInstance().addToRequestQueue(strReq, tag_json_obj);


    }*/
    @Override
    public void onStart() {
        super.onStart();
        getActivity().setTitle("FAQ");
    }
    public void showDialog_ServerError(String errorText)
    {
        final Dialog dialog = new Dialog(getActivity());
        dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
        dialog.setContentView(R.layout.dialog_show_error);
        dialog.getWindow().setLayout(LinearLayout.LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.WRAP_CONTENT);
        dialog.setCancelable(false);
        dialog.show();
        TextView Error_TextView= (TextView) dialog.findViewById(R.id.error_textview);
        Error_TextView.setText(errorText);
        Button DialogOKButton = (Button) dialog.findViewById(R.id.okbutton);
        DialogOKButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                // getActivity().finish();
                dialog.dismiss();
                //System.exit(0);
            }
        });
    }

}
